A = gallery('wathen', 50, 50);
%A = mmread('E:\my-projects\Robotics\SLAM_plus_plus\data\SLAM_sys\intel\system.mtx');
p = amd(A,1);
[L,U] = lu(A);
[Lp,Up] = lu(A(p,p));

figure;
subplot(2,2,1);    spy(A);
title('Sparsity structure of A');

subplot(2,2,2); spy(A(p,p));
title('Sparsity structure of AMD ordered A');

subplot(2,2,3); spy(L+U);
title('Sparsity structure of LU of A');

subplot(2,2,4); spy(Lp+Up);
title('Sparsity structure of LU of AMD ordered A');

set(gcf,'Position',[100 100 800 700]);

R = chol(A, 'upper');
Rp = chol(A(p,p), 'upper');

figure;
subplot(2,2,1);    spy(A);
title('Sparsity structure of A');

subplot(2,2,2); spy(A(p,p));
title('Sparsity structure of AMD ordered A');

subplot(2,2,3); spy(R);
title('Sparsity structure of Cholesky of A');

subplot(2,2,4); spy(Rp);
title('Sparsity structure of Cholesky of AMD ordered A');

set(gcf,'Position',[100 100 800 700]);
